import { apiConfig } from '@/config/api.config';
import { useManageAldeiasContext } from '../hooks/useManageAldeiasContext';
import { Alert, useDataGrid } from '@/components';
import { useCallApi } from '@/hooks';
import { useCallback, useState } from 'react';
import { toast } from 'sonner';
import { Dialog, DialogContent, DialogFooter, DialogHeader } from '@/components/ui/dialog';
import { Button } from '@/components/ui/button';
import { doSaveLogActivity } from '@/actions/GlobalActions';

const API_URL = apiConfig.service_master_data;

const DeleteDialog = () => {
  const { showDeleteDialog, handleDeleteDialog, selectedAldeias } = useManageAldeiasContext();
  const { reload } = useDataGrid();
  const { DeleteData } = useCallApi();
  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });

  const doDeleteAldeias = useCallback(async () => {
    if (!selectedAldeias) {
      toast.error('No Aldeias selected');
      return;
    }

    const response = await DeleteData(`${API_URL}/aldeias/delete/${selectedAldeias}/false`, {
      id: selectedAldeias
    });

    if (response?.status) {
      setAlert({ show: false, message: '' });
      handleDeleteDialog(false, null);
      toast.success('Success Delete Aldeia');
      reload();

      const createActivity = {
        module: 'Manage Aldeia',
        description: `Delete Aldeia => ${selectedAldeias}`,
        action: 'D'
      };

      doSaveLogActivity(createActivity);
    } else {
      setAlert({ show: true, message: response?.message });
      toast.error('Failed Delete Aldeia');
    }
  }, [selectedAldeias, DeleteData, handleDeleteDialog, reload]);

  return (
    <Dialog open={showDeleteDialog} onOpenChange={(open) => handleDeleteDialog(open, null)}>
      <DialogContent className="container-fixed max-w-md flex flex-col p-5 overflow-hidden [&>button]:hidden">
        <DialogHeader className="p-0 border-0 block">
          <Alert variant="warning">
            <h3 className="text-lg">Are you sure?</h3>
            <span className="text-sm">You will delete this data!</span>
          </Alert>
          {alert.show && (
            <Alert variant="danger">
              <h3>{alert.message}</h3>
            </Alert>
          )}
        </DialogHeader>
        <DialogFooter className="flex justify-end items-center gap-4 mt-3">
          <Button variant={'outline'} onClick={() => handleDeleteDialog(false, null)}>
            Cancel
          </Button>
          <Button variant={'destructive'} onClick={() => doDeleteAldeias()}>
            Delete
          </Button>
        </DialogFooter>
      </DialogContent>
    </Dialog>
  );
};

export default DeleteDialog;
